/*
  Name: pcp.c
  Copyright: Copyright  Robert A Bradley 9/9/2005
  Author: Robert A Bradley
  Date: 13/09/2005 14:24
  Description: PCP file creator, and test of pointlib/pcpfile library
*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "pointlib.h"
#include "pcpfile.h"

int main(int argc, char *argv[])
{
    char s[30]="",sx[15]="",sy[15]="";
    Pointlist *points=MakePointlist();
    if (points==NULL) {
        printf("Could not create Pointlist!\n");
        return 1;
    }
    double x,y;
    int quit=0;
    printf("Enter your points in the form \'x y\', with a new line between each point:\n");
    while (!quit) {
        fgets(s,30,stdin);
        if (strcmp(s,"\n")==0 || strlen(s)==0) {
            quit=1;
            break;
        }
        sscanf(s,"%14s%14s",sx,sy);
        while (strcmp(sy,"\n")==0 || strlen(sy)==0) {
              printf("Enter y value: ");
              fgets(sy,15,stdin);
        }
        x=atof(sx);y=atof(sy);
        sx[0]=0;sy[0]=0;s[0]=0;
        Point p;
        p.x=x;p.y=y;
        AddPoint(points,p);
        printf("Read %f, %f\n",x,y);
    }
    int pCount=GetPointCount(points);
    printf("Points: %d\n",pCount);
    int i;
    for (i=0;i<pCount;i++) {
        Point ps=GetPoint(points,i);
        //Point p=*ps;
        printf("%f, %f\n",ps.x,ps.y);
    }
    printf("Converting Pointlist to array ... ");
    Point *pt=PointlistToArray(points);
    printf("done.\n");
    for (i=0;i<pCount;i++) {
        printf("%f, %f\n",pt[i].x,pt[i].y);
    }
    PCPFile pcp;
    pcp.count=pCount;
    pcp.points=pt;
    pcp.plotType=0;
    pcp.weightType=0;
    char filen[1024];
    printf("Enter a filename (enter=pcp.txt): ");
    fgets(filen,1024,stdin);
    if (strlen(filen)>0)
        filen[strlen(filen)-1]=0;
    if (strlen(filen)==0)
        strcpy(filen,"pcp.txt");
    printf("Saving %s (%d)\n",filen,strlen(filen));
    int ret=SavePCPFileFromPointlist(filen,&pcp,points);
    if (ret) {
        printf("Error saving file %s\n",filen);
    }
    free(pt);
    FreePointlist(points);
    return EXIT_SUCCESS;
}
